# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_05_01
  module Models
    #
    # Auto-scale settings for the cluster. The system automatically scales the
    # cluster up and down (within minimumNodeCount and maximumNodeCount) based
    # on the number of queued and running jobs assigned to the cluster.
    #
    class AutoScaleSettings

      include MsRestAzure

      # @return [Integer] Minimum node count. The minimum number of compute
      # nodes the Batch AI service will try to allocate for the cluster. Note,
      # the actual number of nodes can be less than the specified value if the
      # subscription has not enough quota to fulfill the request.
      attr_accessor :minimum_node_count

      # @return [Integer] Maximum node count. The maximum number of compute
      # nodes the cluster can have.
      attr_accessor :maximum_node_count

      # @return [Integer] Initial node count. The number of compute nodes to
      # allocate on cluster creation. Note that this value is used only during
      # cluster creation. Default: 0. Default value: 0 .
      attr_accessor :initial_node_count


      #
      # Mapper for AutoScaleSettings class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AutoScaleSettings',
          type: {
            name: 'Composite',
            class_name: 'AutoScaleSettings',
            model_properties: {
              minimum_node_count: {
                client_side_validation: true,
                required: true,
                serialized_name: 'minimumNodeCount',
                type: {
                  name: 'Number'
                }
              },
              maximum_node_count: {
                client_side_validation: true,
                required: true,
                serialized_name: 'maximumNodeCount',
                type: {
                  name: 'Number'
                }
              },
              initial_node_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'initialNodeCount',
                default_value: 0,
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
