# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_05_01
  module Models
    #
    # Output directory for the job.
    #
    class OutputDirectory

      include MsRestAzure

      # @return [String] ID. The ID of the output directory. The job can use
      # AZ_BATCHAI_OUTPUT_<id> environment variable to find the directory path,
      # where <id> is the value of id attribute.
      attr_accessor :id

      # @return [String] Path prefix. The prefix path where the output
      # directory will be created. Note, this is an absolute path to prefix.
      # E.g. $AZ_BATCHAI_MOUNT_ROOT/MyNFS/MyLogs. The full path to the output
      # directory by combining pathPrefix, jobOutputDirectoryPathSegment
      # (reported by get job) and pathSuffix.
      attr_accessor :path_prefix

      # @return [String] Path suffix. The suffix path where the output
      # directory will be created. E.g. models. You can find the full path to
      # the output directory by combining pathPrefix,
      # jobOutputDirectoryPathSegment (reported by get job) and pathSuffix.
      attr_accessor :path_suffix


      #
      # Mapper for OutputDirectory class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'OutputDirectory',
          type: {
            name: 'Composite',
            class_name: 'OutputDirectory',
            model_properties: {
              id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              path_prefix: {
                client_side_validation: true,
                required: true,
                serialized_name: 'pathPrefix',
                type: {
                  name: 'String'
                }
              },
              path_suffix: {
                client_side_validation: true,
                required: false,
                serialized_name: 'pathSuffix',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
